<?php

class actionGuestbookAdd extends cmsAction {

    public function run() {

        $user = cmsUser::getInstance();

        $model = cmsCore::getModel('moderation');

        $options = $this->options;


        if (!($this->is_moderator_guestboock || cmsUser::isAllowed('guestbook', 'add'))) {

            cmsCore::error404();
        }

        $errors = false;

        $is_captcha_valid = true;

        $form = $this->getForm('guestbook');

        $fieldset_id = $form->getLastFieldsetId();

        if ($this->options['editor'] == '0') {

            $form->addField($fieldset_id, new fieldText('text', array(
                        'title' => LANG_MESSAGE,
                        'options' => array(
                            'max_length' => $this->options['max_len_item']),
                        'rules' => array(
                            array('required'),
            ))));
        } else {

            $form->addField($fieldset_id, new fieldHtml('text', array(
                        'title' => LANG_MESSAGE,
                        'editor_presets' => $this->options['editor_presets'],
                        'options' => array(
                            'max_length' => $this->options['max_len_item'],
                            'editor' => $this->options['editor']),
                        'rules' => array(
                            array('required'),
            ))));
        }
        if ($this->options['on_document_text'] == true) {

            $title_html = "<a class='ajaxlink ajax-modal' href='" . href_to('guestbook', 'text') . "'>" . $this->options['chek_url_title'] . "</a>";
        } else {
            $title_html = $this->options['chek_url_title'];
        }

        $form->addField($fieldset_id, new fieldCheckbox('chek', array(
                    'title' => $title_html,
                    'rules' => array(
                        array('required'),
        ))));
        $is_submitted = $this->request->has('submit');

        if ($user->id) {

            $item['email'] = $user->email;

            $item['nick_name'] = $user->nickname;
        }
        if ($is_submitted) {

            $item = $form->parse($this->request, $is_submitted);

            $errors = $this->valid_ip_mail($item);

            if (!$errors) {

                if (($this->options['groups_user_capcha']['0'] === 0) ||
                        $this->cms_user->isInGroups($this->options['groups_user_capcha'])) {

                    $is_captcha_valid = cmsEventsManager::hook('captcha_validate', $this->request);

                    if (!$is_captcha_valid) {

                        $errors = true;

                        cmsUser::addSessionMessage(LANG_CAPTCHA_ERROR, 'error');
                    }
                }
                if (!$errors) {
                    $errors = $form->validate($this, $item);
                }
            }

            if (!$errors) {
                if ($user->id) {

                    $item['user_id'] = $user->id;
                } else {
                    $item['user_id'] = 0;
                }
                $item['date_pub'] = date('Y-m-d:H-i');

                $item['hesh'] = md5(date('Y-m-d:H-i-s'));

                if ($options['moderation_email'] and ! $access['is_moderator']) {

                    $item['is_send'] = 0;
                } else {

                    $item['is_send'] = 1;
                }

                if ($this->is_moderator_guestboock) {
                    $item['is_approved'] = 1;
                } else {
                    if (!$item['is_send'] or $options['moderation_item']) {

                        $item['is_approved'] = 0;
                    } else {

                        $item['is_approved'] = 1;
                    }
                    if ($item['is_send']) {

                        cmsUser::addSessionMessage(LANG_GUESTBOOK_OK_MESSAGE, 'info');
                    }
                }
                $item = $this->model->addGuestbookItem($item);

                $item['slug'] = $this->model->getGuestbookItemSlug($item);

                $this->model->updateGuestbookItem($item['id'], $item);

                if ($item['is_approved'] && $item['is_send']) {

                    cmsEventsManager::hook('guestbook_add_item', $item);

                    if (!$this->is_moderator_guestboock) {

                        $this->sendEmailEdit($item);
                    }
                }

                if (!$item['is_approved'] && $item['is_send']) {

                    $item['page_url'] = href_to_abs('guestbook', 'viwe', array($item['id']));

                    $succes_text = cmsCore::getController('moderation')->requestModeration('guestbook', $item, true, LANG_GUESTBOOK_MESSAGE);

                    if ($succes_text) {
                        cmsUser::addSessionMessage($succes_text, 'info');
                    }
                }

                if (!$item['is_send']) {

                    // отправляем письмо с подтверждением.
                    $this->sendEmailValid($item);

                    cmsUser::addSessionMessage(LANG_GUESTBOOK_SEND_INFO, 'info');
                }

                $this->redirectTo('guestbook');
            }
        }
        if ($errors && $is_captcha_valid) {
            cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
        }
        if (($this->options['groups_user_capcha']['0'] === 0) ||
                $this->cms_user->isInGroups($this->options['groups_user_capcha'])) {

            $captcha_html = cmsEventsManager::hook('captcha_html');
        }

        $item['chek'] = false;

        return cmsTemplate::getInstance()->render('guestbook_addItem', array(
                    'moder' => $options['moderation_item'],
                    'options' => $this->options,
                    'do' => 'add',
                    'form' => $form,
                    'captcha_html' => isset($captcha_html) ? $captcha_html : false,
                    'errors' => isset($errors) ? $errors : false,
                    'items' => isset($item) ? $item : false
        ));
    }

}
