<?php

class actionGuestbookApprove extends cmsAction {

    public function run($id = null) {

        if (!$id) {
            $id = $this->request->get('id', null);
            if (!$id) {
                cmsCore::error404();
            }
        }
        $item = $this->model->getGuestbookItem($id);

        if (!$this->request->isAjax()) {

            if (!$this->is_moderator_guestboock ) {
                cmsCore::error404();
            }
        } else {
            if (!$item) {
                return $this->cms_template->renderJSON(array(
                            'error' => true,
                            'message' => LANG_ERROR
                ));
            }
        }
        if (!$this->request->isAjax()) {
            if (!$item) {
                cmsCore::error404();
            }
        } else {
            if (!$item) {
                return $this->cms_template->renderJSON(array(
                            'error' => true,
                            'message' => LANG_ERROR
                ));
            }
        }

        $reason = $this->request->get('reason', false);

        $user_model = cmsCore::getModel('users');

        $user = $user_model->getUser($item['user_id']);

        $item['reason'] = $reason;

        $item['author_name'] = $user['nickname'];

        $item['author_email'] = $user['email'];

        $item['page_url'] = href_to_abs('guestbook', 'viwe', $item['slug'] . '.html');

        $controller_moderation = cmsCore::getController('moderation');

        if ($reason) {
            // deleted
            $controller_moderation->approve('guestbook', $item, false, 'moderation_guestbook_refused');

            $this->model->deleteGuestbookItem($item['id']);
        } else {

            $this->model->approvGuestbookItem($item['id']);

            $controller_moderation->approve('guestbook', $item, false, 'moderation_guestbook_approved');

            $controllre_activity = cmsCore::getController('activity');

            if (!$controllre_activity->isTypeExists($this->name, 'approved.guestbook')) {

                $type = array(
                    'is_enabled' => 1,
                    'controller' => $this->name,
                    'name' => 'approved.guestbook',
                    'title' => LANG_RULE_GUESTBOOK_ACTIVITI_MODERATINO_F,
                    'description' => LANG_RULE_GUESTBOOK_ACTIVITI_DESCRIPTION_APPROV_F
                );

                $controllre_activity->addType($type);
            }

            $controllre_activity->addEntry($this->name, 'approved.guestbook', array(
                'user_id' => $this->cms_user->id,
                'subject_title' => $item['title'],
                'subject_id' => $item['id'],
                'subject_url' => $item['page_url'],
                'is_private' => 0,
                'group_id' => null,
                'images' => null,
                'images_count' => 1,
                'is_pub' => 1,
            ));
        }
        if ($this->options['email_mess'] && $item['is_approved'] && $item['rep_id']) {

            $this->requestReplayGuestBook($item);
        }
        cmsEventsManager::hook('guestbook_toggle_item_publication', $item);
        
        $this->sendEmailEdit($item);

        if (!$this->request->isAjax()) {

            $this->redirectTo($this->name, 'viwe', array($item['slug'] . '.html'));
        } else {

            return $this->cms_template->renderJSON(array(
                        'error' => false,
                        'message' => '',
                        'id' => $item['id'],
            ));
        }
    }

}
