<?php

class actionGuestbookDelete extends cmsAction {

    public function run($id = null) {

        if (!$id) {

            cmsCore::error404();
        }

        $item = $this->model->getGuestbookItem($id);

        if (!$item) {

            cmsCore::error404();
        }

        $user = cmsUser::getInstance();

        $is_my = (($item['email'] == $user->email) || ($item['user_id'] == $user->id));
        
        if (!$this->is_moderator_guestboock) {
            if (!(cmsUser::isAllowed('guestbook', 'edit_replay', 'all' ||
                            (cmsUser::isAllowed('guestbook', 'edit_replay', 'own') && $is_my )) ||
                    ($this->is_moderator_guestboock || cmsUser::isAllowed('guestbook', 'edit_item', 'all') ||
                    (cmsUser::isAllowed('guestbook', 'edit_item', 'own') && $is_my ))
                    )) {

                cmsCore::error404();
            }
        }
        if ($item['rep_id']) {

            $this->model->deleteGuestbookItem($id);

            cmsEventsManager::hook('guestbook_delete_item', $id);

            $this->redirectTo($this->name, 'viwe', array($item['rep_id']));
        } else {

            $rep_item = $this->model->filterEqual('rep_id', $id)->getGuestbookItems();

            $this->model->deleteGuestbookItem($id);

            cmsEventsManager::hook('guestbook_delete_item', $id);

            if ($rep_item) {

                foreach ($rep_item as $tmp) {

                    $this->model->deleteGuestbookItem($tmp['id']);

                    cmsEventsManager::hook('guestbook_delete_item', $tmp['id']);
                }
            }
        }
        $model = cmsCore::getModel('moderation');

        $model->closeModeratorTask('guestbook', $id, true, $this->cms_user->id);

        $this->redirectTo($this->name);
    }

}
