<?php

class actionGuestbookEdit extends cmsAction {

    public function run($id = null) {

        $user = cmsUser::getInstance();

        $edit = $this->request->get('edit', false);

        $hesh = $this->request->get('hesh', false);

 
        if ($edit && $hesh) {

            $items = $this->model->getGuestbookItemField($hesh, 'hesh');
        } else {
     
            if (!$id) {
              
                cmsCore::error404();
            }
            $items = $this->model->getGuestbookItem($id);

            if (!$items) {
                cmsCore::error404();
            }
    
            $is_my = (($items['email'] == $user->email) || ($items['user_id'] == $user->id));
          
            if (!$this->is_moderator_guestboock) {
                
                if (!(cmsUser::isAllowed('guestbook', 'edit_item', 'all') ||
                        (cmsUser::isAllowed('guestbook', 'edit_item', 'own') && $is_my ))) {

                    cmsCore::error404();
                }
            }
        }

        $errors = false;

        $is_captcha_valid = true;

        $form = $this->getForm('guestbook');

        $fieldset_id = $form->getLastFieldsetId();

        if ($this->options['editor'] == '0') {

            $form->addField($fieldset_id, new fieldText('text', array(
                        'title' => LANG_MESSAGE,
                        'rules' => array(
                            array('required'),
            ))));
        } else {

            $form->addField($fieldset_id, new fieldHtml('text', array(
                        'title' => LANG_MESSAGE,
                        'editor_presets' => $this->options['editor_presets'],
                        'options' => array(
                            'editor' => $this->options['editor']),
                        'rules' => array(
                            array('required'),
            ))));
        }
        $is_submitted = $this->request->has('submit');


        if ($is_submitted) {

            $items = $form->parse($this->request, $is_submitted);

            if (!$user->id) {

                $is_captcha_valid = cmsEventsManager::hook('captcha_validate', $this->request);

                if (!$is_captcha_valid) {

                    $errors = true;
                }
            }
            if (!$errors) {

                $errors = $form->validate($this, $items);
            }

            if (!$errors) {

                $items['date'] = date('Y-m-d:H-i');

                $items['on_off'] = True;

                // добавляем в базу
                $items['text'] = nl2br($items['text']);

                $this->model->updateGuestbookItem($id, $items);
            }

            $this->redirectTo($this->name, 'viwe', array($id));
        }


        return cmsTemplate::getInstance()->render('guestbook_addItem', array(
                    'do' => 'edit',
                    'form' => $form,
                    'options' => $this->options,
                    'captcha_html' => isset($captcha_html) ? $captcha_html : false,
                    'errors' => isset($errors) ? $errors : false,
                    'items' => isset($items) ? $items : false,
                    'edit' => $edit
        ));
    }

}
