<?php

class actionGuestbookInput extends cmsAction {

    public function run() {

        $options = $this->options;

        if (!$this->isEnabled()) {

            cmsCore::error404();
        }

        $hesh = $this->request->get('hesh', null);

        if (!$hesh) {

            cmsCore::error404();
        }

        $item = $this->model->getGuestbookItemField($hesh, 'hesh');

        if (!$item) {

            cmsCore::error404();
        }

        $item['is_send'] = 1;

        if (!$options['moderation_email'] or !$options['moderation_repley']) {

            $item['is_approved'] = 1;
        }

        $this->model->updateGuestbookItem($item['id'], $item);

        if (!$item['is_approved']) {

            $item['page_url'] = href_to_abs('guestbook', 'viwe', array($item['id']));

            $succes_text = cmsCore::getController('moderation')->requestModeration('guestbook', $item, true, LANG_GUESTBOOK_MESSAGE);

            if ($succes_text) {
                cmsUser::addSessionMessage($succes_text, 'info');
            }

            $this->redirectTo($this->name);
        } else {
            if ($item['is_approved'] && $item['is_send']) {

                cmsEventsManager::hook('guestbook_add_item', $item);

                $this->sendEmailEdit($item);
            }

            cmsUser::addSessionMessage(LANG_GUESTBOOK_OK_MESSAGE, 'info');

            $this->redirectTo($this->name, 'viwe', array($item['slug'] . '.html'));
        }
    }

}
