<?php

class actionGuestbookRepley extends cmsAction {

    public function run($rep_id = null) {

        if (!$rep_id) {

            cmsCore::error404();
        }

        if (!(cmsUser::isAllowed('guestbook', 'replay') || $this->is_moderator_guestboock)) {

            cmsCore::error404();
        }
        $user = cmsUser::getInstance();

        $options = $this->options;

        $is_captcha_valid = true;

        $errors = false;

        $form = $this->getForm('guestbookrepley');

        $fieldset_id = $form->getLastFieldsetId();

        if ($this->options['editor'] == '0') {

            $form->addField($fieldset_id, new fieldText('text', array(
                        'title' => LANG_MESSAGE,
                        'rules' => array(
                            array('required'),
            ))));
        } else {

            $form->addField($fieldset_id, new fieldHtml('text', array(
                        'title' => LANG_MESSAGE,
                        'editor_presets' => $this->options['editor_presets'],
                        'options' => array(
                            'editor' => $this->options['editor']),
                        'rules' => array(
                            array('required'),
            ))));
        }



        $form->addFieldToBeginning($fieldset_id, new fieldString('nick_name', array(
                    'title' => LANG_NICKNAME,
                    'rules' => array(
                        array('required'),
                    )
        )));

        $form->addFieldToBeginning($fieldset_id, new fieldString('email', array(
                    'title' => LANG_EMAIL,
                    'rules' => array(
                        array('required'),
                        array('email'),
                    )
                        ))
        );

        $item = array();

        if ($this->cms_user->is_logged) {
            $item = array(
                'nick_name' => $this->cms_user->nickname,
                'email' => $this->cms_user->email
            );
        }


        $is_submitted = $this->request->has('submit');

        $ritem = $this->model->getGuestbookItem($rep_id);

        if ($is_submitted) {

            $item = $form->parse($this->request, $is_submitted);

            $errors = $form->validate($this, $item);

            $errors = $this->valid_ip_mail($item);

            if (($this->options['groups_user_capcha']['0'] === 0) ||
                    $this->cms_user->isInGroups($this->options['groups_user_capcha'])) {

                $is_captcha_valid = cmsEventsManager::hook('captcha_validate', $this->request);

                if (!$is_captcha_valid) {

                    $errors = true;

                    cmsUser::addSessionMessage(LANG_CAPTCHA_ERROR, 'error');
                }
            }
            if (!$errors) {
                if ($user->id) {

                    $item['user_id'] = $user->id;

                    $item['nick_name'] = $user->nickname;

                    $item['email'] = $user->email;
                } else {

                    $item['user_id'] = 0;
                }
                $item['hesh'] = md5(date('Y-m-d:H-i-s'));

                $item['rep_id'] = $rep_id;

                $item['title'] = $ritem['title'];

                $item['slug'] = $ritem['slug'];

                $item['date_pub'] = date('Y-m-d:H-i');

                if ($options['moderation_email'] and ! $this->is_moderator_guestboock) {

                    $item['is_send'] = 0;
                } else {

                    $item['is_send'] = 1;
                }

                if ($this->is_moderator_guestboock) {

                    $item['is_approved'] = 1;
                } else {
                    if ($options['moderation_email'] or $options['moderation_repley']) {

                        $item['is_approved'] = 0;
                    } else {
                        $item['is_approved'] = 1;
                    }
                    if ($item['is_send']) {

                        cmsUser::addSessionMessage(LANG_GUESTBOOK_OK_MESSAGE, 'info');
                    }
                }
                $item = $this->model->addGuestbookItem($item);

                if ($item['is_approved'] && $item['is_send']) {

                    cmsEventsManager::hook('guestbook_add_item', $item);

                    $this->sendEmailEdit($item);
                }

                if (!$item['is_approved'] && $item['is_send']) {

                    $item['page_url'] = href_to_abs($this->name, 'viwe', array($item['id']));

                    $succes_text = cmsCore::getController('moderation')->requestModeration('guestbook', $item, true, LANG_GUESTBOOK_MESSAGE);

                    if ($succes_text) {

                        cmsUser::addSessionMessage($succes_text, 'info');
                    }
                }

                if ($options['email_mess'] && $item['is_approved'] && $item['is_send']) {

                    $this->requestReplayGuestBook($item);
                }

                if (!$item['is_send']) {

                    // отправляем письмо с подтверждением.
                    $this->sendEmailValid($item);

                    cmsUser::addSessionMessage(LANG_GUESTBOOK_SEND_INFO, 'info');
                }

                $this->redirectTo($this->name);
            }
        }
        if ($errors && $is_captcha_valid) {

            cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
        }
        if (($this->options['groups_user_capcha']['0'] === 0) ||
                $this->cms_user->isInGroups($this->options['groups_user_capcha'])) {

            $captcha_html = cmsEventsManager::hook('captcha_html');
        }
        return cmsTemplate::getInstance()->render('guestbook_repley', array(
                    'do' => 'add',
                    'options' => $this->options,
                    'form' => $form,
                    'captcha_html' => isset($captcha_html) ? $captcha_html : false,
                    'errors' => isset($errors) ? $errors : false,
                    'items' => isset($ritem) ? $ritem : false,
                    'ritem' => isset($item) ? $item : false,
                    'user' => $user
        ));
    }

}
