<?php

class actionGuestbookRepleyEdit extends cmsAction {

    public function run($id = null) {

        $user = cmsUser::getInstance();

        $edit = $this->request->get('edit', null);

        $hesh = $this->request->get('hesh', null);

        if ($edit && $hesh) {

            $items = $this->model->getGuestbookItemField($hesh, 'hesh');
        } else {


            if (!$id) {

                cmsCore::error404();
            }
            $items = $this->model->getGuestbookItem($id);


            if (!$items) {
                cmsCore::error404();
            }

            $is_my_rep = (($items['email'] == $user->email) || ($items['user_id'] == $user->id));

            if (!($this->is_moderator_guestboock || cmsUser::isAllowed('guestbook', 'edit_replay', 'all') ||
                    (cmsUser::isAllowed('guestbook', 'edit_replay', 'own') && $is_my_rep ))) {

                cmsCore::error404();
            }
        }

        if (!$items) {

            cmsCore::error404();
        }

        $errors = false;

        $form = $this->getForm('guestbookrepley');

        $fieldset_id = $form->getLastFieldsetId();

        if ($this->options['editor'] == '0') {

            $form->addField($fieldset_id, new fieldText('text', array(
                        'title' => LANG_MESSAGE,
                        'options' => array(
                            'max_length' => $this->options['max_len_item']),
                        'rules' => array(
                            array('required'),
            ))));
        } else {

            $form->addField($fieldset_id, new fieldHtml('text', array(
                        'title' => LANG_MESSAGE,
                'editor_presets' => $this->options['editor_presets'],
                        'options' => array(
                            'max_length' => $this->options['max_len_item'],
                            'editor' => $this->options['editor']),
                        'rules' => array(
                            array('required'),
            ))));
        }

        $is_submitted = $this->request->has('submit');

        $ritem = $this->model->getGuestbookItem($items['rep_id']);

        if ($is_submitted) {

            $items = $form->parse($this->request, $is_submitted);

            if (!$errors) {

                $errors = $form->validate($this, $items);
            }

            if (!$errors) {

                $items['text'] = nl2br($items['text']);

                $this->model->updateGuestbookItem($id, $items);

                $this->redirectTo($this->name, 'viwe', array($ritem['id']));
            }
        }
        $user = cmsUser::getInstance();

        return cmsTemplate::getInstance()->render('guestbook_repley', array(
                    'do' => 'edit',
                    'form' => $form,
                    'options' => $this->options,
                    'errors' => isset($errors) ? $errors : false,
                    'items' => isset($ritem) ? $ritem : false,
                    'ritem' => isset($items) ? $items : false,
                    'captcha_html' => false,
                    'edit' => $edit,
                    'user' => $user
        ));
    }

}
