<?php

class backendGuestbook extends cmsBackend {

    public $useDefaultOptionsAction = true;
    public $useDefaultPermissionsAction = true;

    public function routeAction($action_name) {


        if ($action_name == 'perms_save') {
            $action_name = 'gbperms_save';
        }

        if ($action_name == 'perms') {
            $action_name = 'gbperms';
        }



        return $action_name;
    }

    public function actionIndex() {
        $this->redirectToAction('viwe');
    }

    public function actionGbperms($subject = '') {

        if (empty($this->useDefaultPermissionsAction)) {
            cmsCore::error404();
        }

        $rules = cmsPermissions::getRulesList($this->name);
        $values = cmsPermissions::getPermissions($subject);

        $groups = cmsCore::getModel('users')->getGroups(true);


        $template_params = array(
            'rules' => $rules,
            'values' => $values,
            'groups' => $groups,
            'subject' => $subject
        );


        return $this->cms_template->render('perms', $template_params);
    }

    public function actionGbpermsSave($subject = '') {

        if (empty($this->useDefaultPermissionsAction)) {
            cmsCore::error404();
        }

        $values = $this->request->get('value', array());
        $rules = cmsPermissions::getRulesList($this->name);

        $groups = cmsCore::getModel('users')->getGroups(true);

        // перебираем правила

        if ($rules) {
            foreach ($rules as $rule) {

                // если для этого правила вообще ничего нет,
                // то присваиваем null
                if (!isset($values[$rule['id']])) {
                    $values[$rule['id']] = null;
                    continue;
                }

                // перебираем группы, заменяем на нуллы
                // значения отсутствующих правил
                foreach ($groups as $group) {
                    if (!isset($values[$rule['id']][$group['id']])) {
                        $values[$rule['id']][$group['id']] = null;
                    }
                }
            }
        }
        cmsUser::addSessionMessage(LANG_CP_PERMISSIONS_SUCCESS, 'success');

        cmsPermissions::savePermissions($subject, $values);

        $this->redirectBack();
    }

    public function getBackendMenu() {
        return array(
            array(
                'title' => LANG_VIEW,
                'url' => href_to($this->root_url, 'viwe')
            ),
            array(
                'title' => LANG_OPTIONS,
                'url' => href_to($this->root_url, 'options')
            ),
            array(
                'title' => LANG_MODERATORS,
                'url' => href_to($this->root_url, 'moderators')
            ),
            array(
                'title' => LANG_PERMISSIONS,
                'url' => href_to($this->root_url, 'perms', 'guestbook')
            )
        );
    }

}
