<?php

class actionGuestbookAjax extends cmsAction {

    public function run() {

        if (!$this->request->isAjax()) {

            cmsCore::error404();
        }

        $grid = $this->loadDataGrid('item');

        $this->model->setPerPage(admin::perpage);

        $filter = array();

        $filter_str = $this->request->get('filter', '');

        if ($filter_str) {

            parse_str($filter_str, $filter);

            $this->model->applyGridFilter($grid, $filter);
        }

        $data = $this->model->filterEqual('rep_id', NULL)->getGuestbookItems(150);

        $total = $this->model->itemsGuestbookTotal();

        $perpage = isset($filter['perpage']) ? $filter['perpage'] : admin::perpage;

        $pages = ceil($total / $perpage);

        cmsTemplate::getInstance()->renderGridRowsJSON($grid, $data, $total, $pages);

        $this->halt();
    }

}
