<?php

class actionGuestbookModeratorsAdd extends cmsAction {

    public function run() {

        if (!$this->request->isAjax()) {

            cmsCore::error404();
        }

        $name = $this->request->get('name', '');

        if (!$name) {

            cmsCore::error404();
        }

        $user = cmsCore::getModel('users')->filterEqual('email', $name)->getUser();

        $model = cmsCore::getModel('moderation');

        if ($user === false) {

            return $this->cms_template->renderJSON(array(
                        'error' => true,
                        'message' => sprintf(LANG_CP_USER_NOT_FOUND, $name)
            ));
        }

        $moderators = $model->getContentTypeModerators('guestbook');

        if (isset($moderators[$user['id']])) {

            return $this->cms_template->renderJSON(array(
                        'error' => true,
                        'message' => sprintf(LANG_MODERATOR_ALREADY, $user['nickname'])
            ));
        }

        $moderator = $model->addContentTypeModerator('guestbook', $user['id']);

        if (!$moderator) {
            return $this->cms_template->renderJSON(array(
                        'error' => true,
                        'message' => LANG_ERROR
            ));
        }

        return $this->cms_template->renderJSON(array(
                    'error' => false,
                    'name' => $user['nickname'],
                    'html' => $this->cms_template->render('ctypes_moderator', array(
                        'moderator' => $moderator,
                        'ctype' => $this->ctype
                            ), new cmsRequest(array(), cmsRequest::CTX_INTERNAL)),
                    'id' => $user['id']
        ));
    }

}
