<?php

class formGuestbookOptions extends cmsForm {

    public $is_tabbed = true;

    public function init() {

        return array(
            array(
                'type' => 'fieldset',
                'title' => LANG_GUESTBOOK_GENERAL,
                'childs' => array(
                    new fieldCheckbox('is_ds_toolbar', array(
                        'title' => sprintf(LANG_GUESTBOOK_BOTTOM_ADD . '%s', LANG_GUESTBOOK_BOTTOM_TOLBAR),
                        'default' => TRUE
                            )),
                    new fieldCheckbox('is_ds_bottom', array(
                        'title' => sprintf(LANG_GUESTBOOK_BOTTOM_ADD . '%s', LANG_GUESTBOOK_BOTTOM_BOTTOM),
                        'default' => TRUE
                            )),
                    new fieldCheckbox('email_mess', array(
                        'title' => LANG_GUESTBOOK_EMAIL_MESS,
                        'default' => FALSE
                            )),
                    new fieldListMultiple('check_typ_bl', array(
                        'title' => LANG_GUESTBOOK_CHECK_BL,
                        'hint' => LANG_GUESTBOOK_CHECK_HINT,
                        'items' => array(
                            0 => LANG_GUESTBOOK_CHECK_NIKNAME,
                            1 => LANG_GUESTBOOK_CHECK_EMAIL,
                            2 => LANG_GUESTBOOK_CHECK_IP
                        )
                            )),
                    new fieldListGroups('groups_user_capcha', array(
                        'title' => LANG_GUESTBOOK_GDOUP_CAPCHA,
                        'hint' => LANG_GUESTBOOK_GDOUP_CAPCHA_HINT,
                        'show_all' => true,
                        'show_guests' => true
                            )),
                )),
            array(
                'type' => 'fieldset',
                'title' => LANG_CP_SETTINGS_EDITOR,
                'childs' => array(
                    new fieldList('editor', array(
                        'title' => LANG_CP_SETTINGS_EDITOR,
                        'default' => LANG_GUESTBOOK_HTML_NO_REDACTOR,
                        'generator' => function($item) {
                            $items = array();
                            $items['0'] = LANG_GUESTBOOK_HTML_NO_REDACTOR;
                            $editors = cmsCore::getWysiwygs();
                            foreach ($editors as $editor) {
                                $items[$editor] = $editor;
                            }
                            return $items;
                        }
                            )),
                    new fieldList('editor_presets', array(
                        'title' => LANG_PARSER_HTML_EDITOR_GR,
                        'is_multiple' => true,
                        'dynamic_list' => true,
                        'select_title' => LANG_SELECT,
                        'multiple_keys' => array(
                            'group_id' => 'field', 'preset_id' => 'field_select'
                        ),
                        'generator' => function($item) {
                            $users_model = cmsCore::getModel('users');

                            $items = [];

                            $groups = $users_model->getGroups(false);

                            foreach ($groups as $group) {
                                $items[$group['id']] = $group['title'];
                            }

                            return $items;
                        },
                        'values_generator' => function() {
                            $items = ['' => 'Textarea'];
                            $editors = cmsCore::getWysiwygs();
                            foreach ($editors as $editor) {
                                $items[$editor] = ucfirst($editor);
                            }
                            $ps = cmsCore::getModel('wysiwygs')->getPresetsList();
                            if ($ps) {
                                foreach ($ps as $key => $value) {
                                    $items[$key] = $value;
                                }
                            }
                            return $items;
                        }
                            ))),
            ),
            array(
                'type' => 'fieldset',
                'title' => LANG_MODERATION,
                'childs' => array(
                    new fieldCheckbox('moderation_item', array(
                        'title' => LANG_GUESTBOOK_MODERATION_ITEM,
                        'hint' => LANG_GUESTBOOK_MODERATION_ITEM_HINT,
                        'default' => FALSE
                            )),
                    new fieldCheckbox('moderation_repley', array(
                        'title' => LANG_GUESTBOOK_MODERATION_REPLEY,
                        'hint' => LANG_GUESTBOOK_MODERATION_REPLEY_HINT,
                        'default' => FALSE
                            )),
                    new fieldCheckbox('moderation_email', array(
                        'title' => LANG_GUESTBOOK_MODERATION_EMAIL,
                        'hint' => LANG_GUESTBOOK_MODERATION_EMAIL_HINT,
                        'default' => FALSE
                            )),
                    new fieldNumber('leter_life', array(
                        'title' => LANG_GUESTBOOK_LETTER_LIFE,
                        'hint' => LANG_GUESTBOOK_LETTER_LIFE_HINT,
                        'default' => 24
                            )),
                )
            ),
            array(
                'type' => 'fieldset',
                'title' => LANG_VIEW,
                'childs' => array(
                    new fieldNumber('perpage', array(
                        'title' => LANG_GUESTBOOK_ITEM_ON_PAGE,
                        'default' => 20
                            )),
                    new fieldNumber('max_len_item', array(
                        'title' => LANG_GUESTBOOK_MAX_LEN_ITEM,
                        'default' => 2048
                            )),
                    new fieldNumber('max_len_item_viwe', array(
                        'title' => LANG_GUESTBOOK_MAX_LEN_ITEM_VIWE,
                        'default' => 2048
                            )),
                )
            ),
            array(
                'title' => LANG_GUESTBOOK_AGREEMENT,
                'type' => 'fieldset',
                'childs' => array(
                    new fieldString('chek_url_title', array(
                        'title' => LANG_GUESTBOOK_URL_TITLE_CHECK,
                        'hint' => LANG_GUESTBOOK_URL_TITLE_CHECK_HINT,
                        'default' => LANG_GUESTBOOK_PERSONAL,
                        'rules' => array(
                            array('required'),
                        ))),
                    new fieldCheckbox('on_document_text', array(
                        'title' => LANG_GUESTBOOK_DOCUMENT_TEXT_ON,
                        'default' => False,
                            )),
                    new fieldHtml('document_text', array(
                        'title' => LANG_GUESTBOOK_CHECK_DOCUMENT_TEXT,
                        'hint' => LANG_GUESTBOOK_CHECK_DOCUMENT_TEXT_HINT,
                        'default' => LANG_GUESTBOOK_CHECK_DOCUMENT_TEXT_HINT,
                            )),
                )),
            array(
                'type' => 'fieldset',
                'title' => LANG_SEO,
                'childs' => array(
                    new fieldText('seo_desc', array(
                        'title' => LANG_SEO_DESC,
                        'hint' => LANG_SEO_DESC_HINT,
                            )),
                    new fieldString('seo_keys', array(
                        'title' => LANG_SEO_KEYS,
                        'hint' => LANG_SEO_KEYS_HINT,
                            )))),
        );
    }

}
