<?php

function grid_item($controller, $ctype_name = false) {

    $options = array(
        'is_draggable' => false,
        'is_pagination' => true,
        'is_sortable' => true,
        'order_by' => 'id',
        'order_to' => 'desc',
        'is_selectable' => true,
    );

    $columns = array(
        'id' => array(
            'title' => 'ID',
            'width' => 20,
            'filter' => 'like'
        ),
        'title' => array(
            'title' => LANG_TITLE,
            'width' => 30,
            'filter' => 'like',
            'href' => href_to($controller->name, 'viwe', array('{id}')),
        ),
        'text' => array(
            'title' => LANG_MESSAGE,
            'width' => 250,
            'filter' => 'like'
        ),
        'nick_name' => array(
            'title' => LANG_NAME,
            'width' => 50,
            'filter' => 'like'
        ),
        'email' => array(
            'title' => LANG_EMAIL,
            'width' => 30,
            'filter' => 'like'
        ),
        'is_approved' => array(
            'title' => LANG_MODERATION,
            'width' => 2,
            'flag' => true, 
            'flag_toggle' => href_to($controller->name, 'item_toggle', '{id}'),
        ),
        'date_pub' => array(
            'title' => LANG_DATE,
            'width' => 50,
            'filter' => 'like'
        ),
    );

    $actions = array(
        array(
            'title' => LANG_VIEW,
            'class' => 'view',
            'href' => href_to($controller->name, 'viwe', array('{id}')),
        // 'confirm' => LANG_VIEW,
        ),
        array(
            'title' => LANG_EDIT,
            'class' => 'edit',
            'href' => href_to($controller->name, 'edit', array('{id}')),
        ),
        array(
            'title' => LANG_DELETE,
            'class' => 'delete',
            'href' => href_to($controller->root_url, 'delete', array('{id}')),
            'confirm' => LANG_DELETE,
        )
    );

    return array(
        'options' => $options,
        'columns' => $columns,
        'actions' => $actions
    );
}
