<?php

class guestbook extends cmsFrontend {

    protected $useOptions = true;
    public $is_moderator_guestboock = false;

    public function before($action_name) {

        // Эта строка обязательна
        parent::before($action_name);

        // Код внутри этого метода будет выполнен 
        // ПЕРЕД запуском любого экшена контроллера
        $this->cms_user->perms = cmsUser::getPermissions($this->cms_user->groups);

        $model = cmsCore::getModel('moderation');

        $this->is_moderator_guestboock = $this->cms_user->is_admin || $model->userIsContentModerator('guestbook', $this->cms_user->id);

        return true;
    }

    public function actionIndex() {

        $this->runAction('index');
    }

    public function sendEmailEdit($item) {

        $letter = array('name' => 'guestbook_edit');

        if (isset($item['rep_id'])) {

            $url = href_to_abs('guestbook', 'repley_edit?edit=true&hesh=' . $item['hesh']);
        } else {
            $url = href_to_abs('guestbook', 'edit?edit=true&hesh=' . $item['hesh']);
        }

        $this->sendEmailGuestBook($item['email'], $letter, array(
            'title' => $this->cms_config->sitename,
            'name' => $item['nick_name'],
            'url' => $url,
            'message' => $item['text'],
        ));
    }

    public function sendEmailValid($item) {

        $letter = array('name' => 'guestbook_validat');

        $this->sendEmailGuestBook($item['email'], $letter, array(
            'title' => $this->cms_config->sitename,
            'name' => $item['nick_name'],
            'url' => '<a href="' . href_to_abs('guestbook', 'input?hesh=' . $item['hesh']) .
            '">' . href_to_abs('guestbook', 'input?hesh=' . $item['hesh']) . '</a>',
        ));
    }

    public function valid_ip_mail($item) {

        $errors = false;

        if (!$this->is_moderator_guestboock) {

            foreach ($this->options['check_typ_bl'] as $param) {

                switch ((int) $param) {

                    case 0: if (!$this->cms_core->getController('auth')->isNameAllowed($item['nick_name'])) {
                            $errors['nick_name'] = sprintf(LANG_AUTH_RESTRICTED_NAME, $item['nick_name']);
                        }
                    case 1: if (!$this->cms_core->getController('auth')->isEmailAllowed($item['email'])) {
                            $errors['email'] = sprintf(LANG_AUTH_RESTRICTED_EMAIL, $item['email']);
                        }

                    case 2: if (!$this->cms_core->getController('auth')->isIPAllowed(cmsUser::get('ip'))) {
                            cmsUser::addSessionMessage(sprintf(LANG_AUTH_RESTRICTED_IP, cmsUser::get('ip')), 'error');
                            $errors['ip'] = sprintf(LANG_AUTH_RESTRICTED_EMAIL, cmsUser::get('ip'));
                        }
                }
            }

            return $errors;
        }
    }

    public function is_moderator() {
        
    }

//    public function isAccess() {
//
//        $this->cms_user->perms = cmsUser::getPermissions($this->cms_user->groups);
//
//        $item = array();
//
//        $model = cmsCore::getModel('moderation');
//
//        $item['is_moderator'] = $this->cms_user->is_admin || $model->userIsContentModerator('guestbook', $this->cms_user->id);
//
//        $item['is_addet_item'] = cmsUser::isAllowed('guestbook', 'add');
//     
//        if (cmsUser::isAllowed($ctype['name'], 'edit', 'all')) {
//            if (
//                (cmsUser::isAllowed($ctype['name'], 'edit', 'own') ||) {
//                cmsCore::error404();
//            }
//        }
//        $item['is_addet_repley'] = cmsUser::isAllowed('guestbook', 'replay');
//
//        $item['is_edit_item'] = cmsUser::isAllowed('guestbook', 'edit_item');
//
//        $item['is_edit_repley'] = cmsUser::isAllowed('guestbook', 'edit_repley');
//
//        return $item;
//    }

    public function sendEmailGuestBook($to, $letter, $data = array(), $is_nl2br_text = true) {

        if (is_array($to)) {

            if (empty($to['email'])) {
                return false;
            }
            if (empty($to['name'])) {
                $to['name'] = false;
            }
        } else {
            if (empty($to)) {
                return false;
            }
            $to = array('email' => $to, 'name' => false);
        }

        if (is_array($letter)) {
            if (empty($letter['text'])) {
                $letter['text'] = cmsCore::getLanguageTextFile("letters/{$letter['name']}");
            }
        } else {
            $letter = array('text' => cmsCore::getLanguageTextFile("letters/{$letter}"));
        }

        if (!$letter['text']) {
            return false;
        }

        $config = cmsConfig::getInstance();

        $data = array_merge(array(
            'site' => $config->sitename,
            'date' => html_date(),
            'time' => html_time()
                ), $data);

        $letter['text'] = string_replace_keys_values($letter['text'], $data);

        $mailer = new cmsMailer();

        $mailer->addTo($to['email'], $to['name']);

        $letter['text'] = $mailer->parseSubject($letter['text']);

        $letter['text'] = $mailer->parseAttachments($letter['text']);

        $mailer->setBodyHTML(($is_nl2br_text ? nl2br($letter['text']) : $letter['text']));

        $result = $mailer->send();

        $mailer->clearTo()->clearAttachments();

        return $result;
    }

    //============================================================================//

    public function requestModerationGuestBook($item, $is_new_item = true) {

        $ctype_name = 'guestbook';

        $model = cmsCore::getModel('moderation');

        $moderator_id = $model->getNextModeratorId($ctype_name);

        $users_model = cmsCore::getModel('users');

        $moderator = $users_model->getUser($moderator_id);

        $messages_controller = cmsCore::getController('messages', $this->request);

        $messages = LANG_GUESTBOOK_MESSAGE . '<a href="' . href_to_abs($ctype_name, 'viwe', $item['id']) . '">' . href_to_abs($ctype_name, 'viwe', $item['id']) . '</a> ';

        $messages_controller->addRecipient($moderator_id);

        $messages_controller->sendNoticePM(array('content' => nl2br($messages)));

        $messages_controller->clearRecipients();

        cmsUser::addSessionMessage(sprintf(LANG_MODERATION_IDLE, $moderator['nickname']), 'info');

        $to = array('email' => $moderator['email'], 'name' => $moderator['nickname']);

        $letter = array('name' => 'guestbook_new');

        $this->sendEmailGuestBook($to, $letter, array(
            'nickname' => $to['name'],
            'message' => $item['text'],
            'date' => $item['date'],
            'page_url' => href_to_abs($ctype_name, 'viwe', $item['id']),
            'page_title' => $item['title'],
            'author' => $item['nick_name']
        ));
    }

    public function cophtml() {

        $html = '<a class="cophtml" href="https://blog-winviruzz.ru"> &copy; blog-winviruzz.ru</a>';

        return $html;
    }

    public function requestReplayGuestBook($item) {

        $ctype_name = 'guestbook';

        $rep = $this->model->getGuestbookItem($item['rep_id']);

        $to = array('email' => $rep['email'], 'name' => $rep['nick_name']);

        $letter = array('name' => 'guestbook_new_replay');

        $this->sendEmailGuestBook($to, $letter, array(
            'nickname' => $to['name'],
            'message' => $item['text'],
            'date' => $item['date_pub'],
            'page_url' => href_to_abs($ctype_name, 'viwe', $rep['id']),
            'page_title' => $item['title'],
            'author' => $item['nick_name']
        ));
    }

//============================================================================//
}
