<?php
$model = cmsCore::getModel('users');
$content = cmsCore::getModel('content');
$this->addcss('templates/default/controllers/guestbook/style.css');
$this->setPageTitle(LANG_GUESTBOOK_CONTROLLER . ' - ' . $items['title']);
$this->addBreadcrumb(LANG_GUESTBOOK_CONTROLLER, href_to('guestbook'));
$this->addBreadcrumb($items['title'], href_to_current());

if (!$items['is_approved'] && $this->controller->is_moderator_guestboock) {
    $this->addToolButton(array(
        'class' => 'accept',
        'title' => LANG_MODERATION_APPROVE,
        'href' => href_to($this->controller->name, 'approve', $items['id'])
    ));
}
$this->setMeta($options['seo_keys'], html_strip($items['title'], 200));
?>
<h1><?php echo html(LANG_GUESTBOOK_CONTROLLER) ?></h1>    
<div class="dg-content">
    <?php
    if ($items) {
        $is_my = (($items['email'] == $user->email) || ($items['user_id'] == $user->id));
        ?>
        <div class="gb-message">
            <?php
            echo $this->renderChild('message', array(
                'items' => $items,
                'user' => $user,
                'is_menu' => true,
                'is_my' => $is_my,
                'approve' => false
            ));
            ?>  

        </div>

        <?php
    } else {
        echo LANG_LIST_EMPTY;
    }
    ?>

    <div class="gb-cop">
        <?php echo $this->controller->cophtml(); ?>
    </div>
</div>

<script type="text/javascript">
    $(function () {
        var $allVideosYoutube = $("iframe[src^='//www.youtube.com']");
        var $allVideosVimeo = $("iframe[src^='//player.vimeo.com']");
        $fluidEl = $(".gb-message-mes_text");
        $allVideosYoutube.each(function () {
            $(this).data('aspectRatio', this.height / this.width).removeAttr('height').removeAttr('width');
        });
        $allVideosVimeo.each(function () {
            $(this).data('aspectRatio', this.height / this.width).removeAttr('height').removeAttr('width');
        });
        $(window).resize(function () {
            var newWidth = $fluidEl.width();
            $allVideosYoutube.each(function () {
                var $el = $(this);
                $el.width(newWidth).height(newWidth * $el.data('aspectRatio'));
            });
            $allVideosVimeo.each(function () {
                var $el = $(this);
                $el.width(newWidth).height(newWidth * $el.data('aspectRatio'));
            });
        }).resize();
    });</script>