var icms = icms || {};

icms.moderationpanel = (function ($) {

    this.approve = function (id) {

        $.post($('#guestbook_moderation_urls').data('approve-url'), {id: id}, function (result) {

            if (result == null || typeof (result) == 'undefined' || result.error) {
                icms.moderationpanel.error(result.message);
                return false;
            } else {
                $('#controller_wrap #id_' + result.id).remove();
                icms.moderationpanel.setModerationCounter();
            }

        }, 'json');

        return false;
    };

    this.remove = function (id, is_reason) {

        var c = $('#controller_wrap #id_' + id);

        var reason = '';

        if (is_reason) {
            reason = prompt(LANG_MODERATION_REFUSE_REASON);
            if (!reason) {
                return false;
            }
        }
        $.post($('#guestbook_moderation_urls').data('approve-url'), {id: id, reason: reason}, function (result) {

            if (result == null || typeof (result) == 'undefined' || result.error) {
                icms.moderationpanel.error(result.message);
                return;
            }
            $(c).remove();
            icms.moderationpanel.setModerationCounter();
        }, "json");

        return false;
    };

    this.error = function (message) {
        icms.modal.alert(message);
        this.restoreForm(false);
    };

    this.setModerationCounter = function () {

        var menu = $('#moderation_content_pills .pills-menu-small .active .counter');

        var current_count = $('#controller_wrap > .dg-content').length;

        if (current_count > 0) {
            $(menu).html(current_count);
        } else if ($('#controller_wrap + .pagebar').length > 0) {
            location.reload();
        }

    };

    return this;

}).call(icms.moderationpanel || {}, jQuery);

